#include "grtest.h"

extern int capget(struct __user_cap_header_struct * header, const struct __user_cap_data_struct * data);

int chroot_caps()
{
	int ret;
	pid_t pid;
	struct __user_cap_header_struct header;
	struct __user_cap_data_struct data;
	int status;
	
	ret = chroot("/tmp");
	
	if (ret)
		return grtest_error("Unable to chroot.");
	
	header.version = _LINUX_CAPABILITY_VERSION;
	header.pid = 0;
	data.effective = 0;
	data.permitted = 0;
	data.inheritable = 0;
	
	ret = capget(&header, &data);
	if (ret)
		return grtest_error("capset failed.");
	
	if (data.permitted & (1 << CAP_SYS_RAWIO))
		return GRSEC_TEST_FAILED;
	
	pid = fork();
	
	if (pid == 0) {
		
		ret = capget(&header, &data);
		if (ret)
            grtest_error("capset failed.");
		
		if (data.permitted & (1 << CAP_SYS_RAWIO))
            exit(GRSEC_TEST_FAILED);
		else
            exit(GRSEC_TEST_PASSED);

	} else if (pid > 0) {
		wait(&status);
		status = status / 256;
	} else if (pid < 0) {
		return GRSEC_TEST_FORKFAIL;
	}
	
	return status;
}
