#include "grtest.h"

int chroot_chmod()
{
	int ret, fd, status;
	char pathname[64] = {0};
	
	ret = chroot("/tmp");
	
	if (ret)
		return grtest_error("Unable to chroot.");
	
	snprintf(pathname, sizeof(pathname) - 1, "/test000%d_chmod", getpid());
	
	fd = open(pathname, O_WRONLY | O_CREAT | O_EXCL, 0755);
	
	if (fd < 0)
		return grtest_error("Unable to create file.");
	
	ret = fchmod(fd, S_ISUID | S_ISGID);
	
	if (!ret)
		status = GRSEC_TEST_FAILED;
	else
		status = GRSEC_TEST_PASSED;
	
	close(fd);

	if ( status == GRSEC_TEST_PASSED ) {
		
		ret = chmod(pathname, S_ISUID | S_ISGID);
		
		if (!ret)
			status = GRSEC_TEST_FAILED;
		else
			status = GRSEC_TEST_PASSED;
	}

	unlink(pathname);
	
	return status;
}
