#include "grtest.h"

int chroot_chroot()
{
	int ret, status;
	struct stat fstat, fstat2;
	char template[] = "chroot_test_XXXXXX";
	char *dir;
	pid_t pid;

	if(stat("/", &fstat))
		return grtest_error("Unable to stat /.");

	ret = chdir("/tmp");

    if (ret)
		return grtest_error("Unable to chdir.");
	
	dir = mkdtemp(template);
	
	// fork so we can remove the created temp directory if the test passes

	pid = fork();

    if (pid == 0) {

		ret = chroot(".");
		
		if (ret)
			grtest_error("Unable to chroot.");
		
		if (!dir)
			grtest_error("Unable to make temp directory.");
		
		ret = chroot(dir);
		
		if (ret)
			grtest_error("Unable to chroot.");
		
		chdir("..");
		chdir("..");
		chdir("..");
		chdir("..");
		chdir("..");
		chdir("..");
		chroot(".");
		
		if(stat("/", &fstat2))
			grtest_error("Unable to stat /.");
		
		if (fstat.st_ino == fstat2.st_ino && fstat.st_dev == fstat2.st_dev)
			exit(GRSEC_TEST_FAILED);
		else
			exit(GRSEC_TEST_PASSED);
		
	} else if (pid > 0) {
        wait(&status);
		status = status / 256;
    } else if (pid < 0) {
        return GRSEC_TEST_FORKFAIL;
    }

	rmdir(dir);

	return status;
}
