#include "grtest.h"
#include <sys/mount.h>

int chroot_mount()
{
    int ret, status;
    char *dir;
    char template[] = "mount_test_XXXXXX";
    pid_t pid;

    ret = chdir("/tmp");

    dir = mkdtemp(template);

    pid = fork();

    if (pid == 0) {

		ret = chroot(".");

		if (ret)
			printf("Unable to chroot.");

		ret = mount("none", dir, "tmpfs", MS_MGC_VAL, NULL);

		if ( ret == -1 )
			exit(GRSEC_TEST_PASSED);
		else {
			umount(dir); // test failed, unmount it
			exit(GRSEC_TEST_FAILED);
		}

    } else if (pid > 0) {
        wait(&status);
        status = status / 256;
    } else if (pid < 0) {
        return GRSEC_TEST_FORKFAIL;
    }

    rmdir(dir);

    return status;
}
