#include "grtest.h"

#ifndef PTRACE_ATTACH
#define PTRACE_ATTACH PT_ATTACH
#endif

int chroot_ptrace()
{
	int ret, status;
	pid_t pid, ppid;
	
	ppid = getpid();

	pid = fork();
	
    if (pid == 0) {

		ret = chroot("/tmp");
		
		if (ret)
			grtest_error("Unable to chroot.");
		
		ret = ptrace(PTRACE_ATTACH, ppid, NULL, NULL);
		
		if (!ret) {
			wait(&status);
			exit(GRSEC_TEST_FAILED);
		}
		else
			exit(GRSEC_TEST_PASSED);
		
	} else if (pid > 0) {
		wait(&status);
		status = status / 256;
	} else if (pid < 0) {
		return GRSEC_TEST_FORKFAIL;
	}
	
	return status;
}
