#include "grtest.h"

#ifndef SYS__sysctl
_syscall1(int, _sysctl, struct __sysctl_args *, args);
#endif

int sysctl(int *name, int nlen, void *oldval, size_t *oldlenp,
		   void *newval, size_t newlen)
{
	struct __sysctl_args args={name,nlen,oldval,oldlenp,newval,newlen};
#ifdef SYS__sysctl
	return syscall(SYS__sysctl, &args);
#else
	return _sysctl(&args);
#endif
}

#define SIZE(x) sizeof(x)/sizeof(x[0])

int chroot_sysctl()
{
	int ret;
	int name[] = { CTL_KERN, KERN_RANDOM, RANDOM_POOLSIZE };
	int newval = 1;
	size_t newlen = sizeof(newval);
	
	ret = chroot("/tmp");
	
	if (ret)
		return grtest_error("Unable to chroot.");
	
	ret = sysctl(name, SIZE(name), 0, 0, &newval, newlen);
	
	if (!ret)
		return GRSEC_TEST_FAILED;
	else
		return GRSEC_TEST_PASSED;

}
