#include "grtest.h"

int execve_limiting() {

	int ret, status;
	pid_t pid;
	const struct rlimit lim = { 0, 0 };

	pid = fork();

	if (pid == 0) {
		
		ret = setuid(1);

		if (ret)
			grtest_error("Unable to setuid non-root.");

		ret = setrlimit(RLIMIT_NPROC, &lim);
		
		if (ret != 0)
			grtest_error("setrlimit failed.");
		
		pid = fork();

		// first check to make sure the normal limiting denies the fork()
		if (pid == 0) {
			exit(0);
		} else if (pid > 0) {
			return grtest_error("fork() rlimit test failed");
		}
		
		// dirty hack; /bin/false just so happens to return the same current
		// value that GRSEC_TEST_FAILED is defined as
		execve("/bin/false", NULL, NULL);
		
		// only get here if execve failed, which is what we want
		exit(GRSEC_TEST_PASSED);

	} else if (pid > 0) {
		wait(&status);
		status = status / 256;
	} else {
		return GRSEC_TEST_FORKFAIL;
	}

	return status;
}
