#include "grtest.h"

int fifo()
{
	int ret, status;
	char filename[64] = {0};
	
	ret = setreuid(-1, 1);
	
	if (ret)
		return grtest_error("Unable to setreuid to non-root.");
	
	snprintf(filename, sizeof(filename), "/tmp/test%d_fifos", getpid());
	
	ret = mknod(filename, S_IFIFO | 0777, 0);
	
	if (ret)
		return grtest_error("Unable to create fifo.");

	ret = setreuid(0,0);
	
	if (ret)
		return grtest_error("Unable to change back to root");

	//ret = open(filename, O_WRONLY | O_CREAT );
	ret = open(filename, O_RDONLY | O_CREAT | O_NONBLOCK, 0600);
	
	if (ret < 0)
		status = GRSEC_TEST_PASSED;
	else
		status = GRSEC_TEST_FAILED;
	
	unlink(filename);
	
	return status;
}
