#include "grtest.h"

int gr_link()
{
	int ret, status;
	char filename[64] = {0};
	pid_t pid;
	
	snprintf(filename, sizeof(filename), "/tmp/test%d_hardlink", getpid());

	// fork so we can unlink the created file upon failure 

	pid = fork();

	if (pid == 0) {

		ret = setuid(1);
		
		if (ret)
			grtest_error("Unable to setuid to non-root.");
	
		ret = link("/etc/passwd", filename);
	
		/* EXDEV */
		if (ret && errno == 18)
			exit(GRSEC_TEST_NA);
		else if (ret)
			exit(GRSEC_TEST_PASSED);
		else
			exit(GRSEC_TEST_FAILED);
		
	} else if (pid > 0) {
        wait(&status);
		status = status / 256;
    } else if (pid < 0) {
        return GRSEC_TEST_FORKFAIL;
    }
	
	unlink(filename);

	return status;
}
