#include "grtest.h"

// TODO: split into different functions... there are 5 tests in here

int memkmemport()
{
	int fd, ret;
	void *retp;
	
	// denied write of /dev/mem
    // TODO: make /dev/mem if not exist
	
	fd = open("/dev/mem", O_RDWR);
	
	if (fd < 0)
		return grtest_error("Unable to open file.");
	
	ret = write(fd, "blah", 4);
	
	if (ret >= 0)
		return GRSEC_TEST_FAILED;
	
	// denied mmap write of /dev/kmem
	
	retp = mmap(NULL, 1000, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0x2000);
	
	close(fd);
	
	if (retp != MAP_FAILED)
		return GRSEC_TEST_FAILED;
	
	// denied open of /dev/port
	
	ret = open("/dev/port", O_RDONLY);
	
	if (ret >= 0) {
		close(ret);
		return GRSEC_TEST_FAILED;
	}
	
	// denied write of /dev/kmem
	// TODO: make /dev/kmem if not exist

	fd = open("/dev/kmem", O_RDWR);
	
	if (fd < 0)
		return grtest_error("Unable to open file.");
	
	ret = write(fd, "blah", 4);
	
	if (ret >= 0)
		return GRSEC_TEST_FAILED;
	
	// denied mmap write of /dev/kmem
	
	retp = mmap(NULL, 1000, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
	
	close(fd);
	
	if (retp == MAP_FAILED)
		return GRSEC_TEST_PASSED;
	else
		return GRSEC_TEST_FAILED;

}
