#include "grtest.h"

int gr_symlink()
{
	int ret;
	char filename[64] = {0};
	
	ret = setreuid(-1, 1);
	
	if (ret)
		return grtest_error("Unable to setreuid to non-root.");
	
	snprintf(filename, sizeof(filename), "/tmp/test%d_symlink", getpid());
	
	ret = symlink("/etc/passwd", filename);
	
	if (ret)
		return grtest_error("Unable to create symlink");
	
	ret = setreuid(0,0);
	
	if (ret)
		return grtest_error("Unable to change back to root");
	
	ret = open(filename, O_RDONLY);
	
    unlink(filename);

	if (ret < 0)
		return GRSEC_TEST_PASSED;
	else
		return GRSEC_TEST_FAILED;

}
