#include "grtest.h"

// This test works assuming all TPE options are enabled, and the
// trusted group is not 1

int tpe() {
	
	pid_t pid;
	int ret, status;

	ret = chdir("/tmp");

	if (ret)
		return grtest_error("Unable to chdir.");

	pid = fork();

	if (pid == 0) {

		ret = setuid(1);

		if (ret)
			grtest_error("Unable to setuid non-root.");

		ret = system("/bin/cp /bin/ls ./");
		if (ret < 0 || ret > 0)
			grtest_error("Unable to copy test binary");

		ret = system("./ls &> /dev/null");

		if (ret < 0 || ret > 0)
			exit(GRSEC_TEST_PASSED);
		else
			exit(GRSEC_TEST_FAILED);

	} else if (pid > 0) {
		wait(&status);
		status = status / 256;
	} else if (pid < 0) {
		return GRSEC_TEST_FORKFAIL;
	}

	unlink("ls");
	
	return status;
}
